/*
  Scrivere la funzione 

  int my_strlen(char *s)

  che restituisce il numero di caratteri della stringa s.

  Scrivere un programma che provi questa funzione leggendo una stringa 
  da tastiera. Si può assumere che la stringa in input contenga non più 
  di 1000 caratteri. 
*/

#include <stdio.h>

#define MAXLEN (1000)

// una prima implementazione
int my_strlen(char *s){

  int i = 0;
  while ( s[i] != '\0' ) i++; // determina l'indice del carattere terminatore '\0'
  return i;

}

// implementazione ottimizzata basata sull'aritmetica dei puntatori (vedi lezione 3)
int my_strlen1(char *s){

  char *t = s;
  while ( *t != '\0' ) t++;
  return (t - s);

}

// come? pensate a questa versione
int my_strlen2(char *s){

  char *t = s;
  while ( *t++ ) ;
  return (t - s - 1);

}

int main(){

  char str[MAXLEN+1];
  scanf("%s", str);

  printf("%d\n", my_strlen(str));
  printf("%d\n", my_strlen1(str));
  printf("%d\n", my_strlen2(str));
  return 0;

}
