/*
  Scrivere la funzione 

  char * my_strcat(char *s1, char *s2)

  che restituisce un puntatore alla stringa ottenuta concatenando 
  le stringhe puntate da src e dest.

  Scrivere un programma che legga due stringhe da tastiera e stampando 
  la stringa e stampi la contatenazione delle due. Si può assumere che le
  stringhe in input contengano non più di 1000 caratteri. 

*/
#include <stdlib.h>
#include <stdio.h>

#define MAXLEN (1000)

// una prima implementazione
int my_strlen(char *s){

  int i = 0;
  while ( s[i] != '\0' ) i++; // determina l'indice del carattere terminatore '\0'
  return i;

}

char * my_strcat(char *s1, char *s2) {

  char *strf; // la stringa finale
  char *tf;
  int i, j, lenf; // la sua lunghezza escluso '\0' finale
  
  lenf = my_strlen(s1);
  lenf += my_strlen(s2);

  strf = malloc( (lenf+1)*sizeof(char) ); // alloca sufficiente spazio per la stringa finale e '\0'
  if(strf == NULL) return NULL;
  
  /* copia la prima stringa */
  tf = strf; 
  while ( *s1 != '\0' ) {
      *tf = *s1; 
      s1++; tf++;
  }

  /* copia la seconda stringa */
  while ( *s2 != '\0' ) {
      *tf = *s2; 
      s2++; tf++;
  }

  *tf = '\0';
  
  return strf;
}

int main(){

  char str1[MAXLEN+1], str2[MAXLEN+1], *str3;
  scanf("%s%s", str1, str2);

  str3 = my_strcat(str1, str2);
  if(str3 == NULL) exit(1);

  printf("%s\n", str3);
  
  free(str3);
  return 0;

}
